# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free
%define namedversion    7.2.2.v20101205

Name:           jetty7-integration
Summary:        Jetty 7 Integration Project
Url:            http://www.eclipse.org/jetty/
Version:        7.2.2
Release:        0.20101205.1%{?dist}
Epoch:          0
License:        Apache Software License 2.0
Group:          Development/Libraries
Source0:        jetty-integration-7.2.2.v20101205.tgz
# svn export http://svn.codehaus.org/jetty/jetty/tags/jetty-7.2.2.v20101205/ jetty-integration-7.2.2.v20101205/
# tar czf jetty-integration-7.2.2.v20101205.tgz jetty-integration-7.2.2.v20101205/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Source99:       http://mirrors.ibiblio.org/pub/mirrors/maven2/org/eclipse/jetty/toolchain/jetty-enforcer-rules/1.0/jetty-enforcer-rules-1.0.jar
Patch0:         jetty7-integration-tests-pom.patch
Patch1:         jetty7-integration-tests-SSLContextTest.patch
Patch2:         jetty7-integration-setuid-java-pom.patch
Patch3:         jetty7-integration-spring-pom.patch
Patch4:         jetty7-integration-example-async-rest-webapp-pom.patch
Patch5:         jetty7-integration-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven2-default-skin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  mojo-maven2-natives
BuildRequires:  apache-commons-parent
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  derby
BuildRequires:  geronimo-genesis
BuildRequires:  jetty-assembly-descriptors
BuildRequires:  jetty-build-support
BuildRequires:  jetty-artifact-remote-resources
BuildRequires:  jetty-servlet-3.0-api
BuildRequires:  jetty7
BuildRequires:  jsslutils
BuildRequires:  spring2-all

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:          java >= 0:1.6.0
Requires:          servlet_3_0_api

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
The Jetty Web Server provides a HTTP server and Servlet
container capable of serving static and dynamic contend
either from a standalone or embedded instantiations. From
jetty-7, the jetty webserver and other core compoments are
hosted by the eclipse foundation. The project provides:
* Asynchronous HTTP Server
* Standard based Servlet Container
* Web Sockets server
* Asynchronous HTTP Client
* OSGi, JNDI, JMX, JASPI, AJP support

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n jetty-integration-%{namedversion}
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
rm jetty-integration-tests/src/test/java/org/mortbay/jetty/integration/jaas/LdapLoginModuleTest.java

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
mkdir -p $MAVEN_REPO_LOCAL/org/eclipse/jetty/toolchain/jetty-enforcer-rules/1.0/
cp %{SOURCE99} $MAVEN_REPO_LOCAL/org/eclipse/jetty/toolchain/jetty-enforcer-rules/1.0/jetty-enforcer-rules-1.0.jar
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
ln -s $(pwd)/jetty-setuid/pom.xml $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/JPP.jetty6.ext-jetty6-libsetuid.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.mortbay.jetty jetty-integration-project %{namedversion} JPP/%{name} project
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-project.pom

%add_to_maven_depmap org.mortbay.jetty jetty-ant %{namedversion} JPP/%{name} ant
install -m 644 jetty-ant/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ant.pom
install -m 644 jetty-ant/target/jetty-ant-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/ant-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-blazeds %{namedversion} JPP/%{name} blazeds
install -m 644 jetty-blazeds/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-blazeds.pom
install -m 644 jetty-blazeds/target/jetty-blazeds-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/blazeds-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-integration-tests %{namedversion} JPP/%{name} integration-tests
install -m 644 jetty-integration-tests/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-integration-tests.pom
install -m 644 jetty-integration-tests/target/jetty-integration-tests-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-tests-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-j2sehttpspi %{namedversion} JPP/%{name} j2sehttpspi
install -m 644 jetty-j2sehttp-spi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-j2sehttpspi.pom
install -m 644 jetty-j2sehttp-spi/target/jetty-j2sehttpspi-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/j2sehttpspi-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-jspc-maven-plugin %{namedversion} JPP/%{name} jspc-maven-plugin
install -m 644 jetty-jspc-maven-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jspc-maven-plugin.pom
install -m 644 jetty-jspc-maven-plugin/target/jetty-jspc-maven-plugin-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jspc-maven-plugin-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-maven-plugin %{namedversion} JPP/%{name} jetty-maven-plugin
install -m 644 jetty-maven-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jetty-maven-plugin.pom
install -m 644 jetty-maven-plugin/target/jetty-maven-plugin-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jetty-maven-plugin-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-pkcs12 %{namedversion} JPP/%{name} pkcs12
install -m 644 jetty-pkcs12/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pkcs12.pom
install -m 644 jetty-pkcs12/target/jetty-pkcs12-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/pkcs12-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-runner %{namedversion} JPP/%{name} runner
install -m 644 jetty-runner/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-runner.pom
install -m 644 jetty-runner/target/jetty-runner-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/runner-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-setuid %{namedversion} JPP/%{name} setuid
install -m 644 jetty-setuid/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-setuid.pom

%add_to_maven_depmap org.mortbay.jetty jetty-setuid-java %{namedversion} JPP/%{name} setuid-java
install -m 644 jetty-setuid/modules/java/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-setuid-java.pom
install -m 644 jetty-setuid/modules/java/target/jetty-setuid-java-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/setuid-java-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-setuid-test %{namedversion} JPP/%{name} setuid-test
install -m 644 jetty-setuid/modules/test/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-setuid-test.pom
install -m 644 jetty-setuid/modules/test/target/jetty-setuid-test-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/setuid-test-%{version}.jar

%add_to_maven_depmap org.mortbay.jetty jetty-spring %{namedversion} JPP/%{name} spring
install -m 644 jetty-spring/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spring.pom
install -m 644 jetty-spring/target/jetty-spring-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/spring-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 example-async-rest-webapp/target/async-rest.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/asnc-rest-%{version}.war
install -m 644 test-annotation-webapp/target/test-annotation-webapp-7.2.2.v20101205-config.jar \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/test-annotation-webapp-config-%{version}.jar
install -m 644 test-annotation-webapp/target/test-annotation-webapp-7.2.2.v20101205.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/test-annotation-webapp-%{version}.war
install -m 644 test-jaas-webapp/target/test-jaas-webapp-7.2.2.v20101205-config.jar \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/test-jaas-webapp-config-%{version}.jar
install -m 644 test-jaas-webapp/target/test-jaas-webapp-7.2.2.v20101205.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/test-jaas-webapp-%{version}.war
install -m 644 test-jndi-webapp/target/test-jndi-webapp-7.2.2.v20101205-config.jar \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/test-jndi-webapp-config-%{version}.jar
install -m 644 test-jndi-webapp/target/test-jndi-webapp-7.2.2.v20101205.war \
               $RPM_BUILD_ROOT%{_datadir}/%{name}/test-jndi-webapp-%{version}.war
(cd $RPM_BUILD_ROOT%{_datadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_datadir}/%{name} && for war in *-%{version}.war; do ln -sf ${war} `echo $war| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_datadir}/%{name}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Mon Aug 01 2011 Ralph Apel <r.apel at r-apel.de> 0:7.2.2-0.20101205.1
- First release
